
;IncludePath "..": IncludeFile "Vector.pb4"



Procedure Debug_Point(*ptr.Point)
  If *ptr
    Debug Str(*ptr\x) + "," + Str(*ptr\y)
  EndIf
EndProcedure


Procedure Debug_Points(*Vector.Vector)
  *ptr.Point
  Vector_Reset(*Vector)
  While Vector_NextElement(*Vector)
    *ptr = Vector_Get(*Vector, #Vector_CurrentElement, #Null)
    Debug_Point(*ptr)
  Wend
EndProcedure


Procedure Point_Sort(*c1.Point, *c2.Point)
  retour.l = #Vector_Compare_Equal ; 0
  If *c1\x <> *c2\x
    If *c1\x < *c2\x
      retour = #Vector_Compare_Less ;-1
    Else
      retour = #Vector_Compare_More ;1
    EndIf
  ElseIf *c1\y <> *c2\y
    If *c1\y < *c2\y
      retour = #Vector_Compare_Less ;-1
    Else
      retour = #Vector_Compare_More ;1
    EndIf
  EndIf

  ProcedureReturn retour
EndProcedure



point.Point
point\x = 0
point\y = 0


; Creation du Vector
*Vector.Vector = Vector_CreateFromSimpleStructure(SizeOf(Point), @Point_Sort())


; Ajout de 100 lments
For i = 1 To 100
  point\x = Random(30) - 15
  point\y = Random(30) - 15
  Vector_AddElement(*Vector, @point, #Vector_CurrentElement)
Next i



; Affichage de tout le Vector
Debug_Points(*Vector)



Debug " ----------- "
Vector_Sort(*Vector, #Null)
Debug_Points(*Vector)


; Libration de la mmoire
Vector_Free(*Vector)


; IDE Options = PureBasic 4.10 (Windows - x86)
; CursorPosition = 54
; Folding = 6
; EnableThread
; SubSystem = UserLibThreadSafe